import React, {Fragment} from 'react'

export const MetaPlate = ({ data, children }) => {
  console.log(children, data)
  const buildProps = (data, {props:{prop, keyDataKey, sourceDataKey}}) => 
                        ({[prop]: data,
                            key:  data[keyDataKey]})
  const build = (data, meta) => {
      if (!meta) return;
      if (data instanceof Array){
          if (meta instanceof Array) meta = meta[0];
          const Render = meta.type
          if (!meta.props.children) return <Render {...buildProps(data, meta)} />
          return  (<Render {...buildProps(data, meta)}>
              {data.map(d => build(d, meta.props.children))}
              </Render>
          )
      }
      else if (data instanceof Object){
          if (!(meta instanceof Array)) meta = [meta]

          return meta.map(m => {
              const Render = m.type
              const {sourceDataKey}  = m.props
              const d = sourceDataKey ? data[sourceDataKey] : data
              if (!d) return <></>
              if (d instanceof Array) return build(d, m)
              return <Render {...buildProps(d, m)} children={build(d, m.props.children)} />
          })
      }
  }
  return <React.Fragment>{build(data, children)}</React.Fragment>
}
